package com.bonus.canteen.core.menu.vo;

import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjectUtil;
import com.bonus.canteen.core.common.utils.SysUtil;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Optional;

@ApiModel("菜品详情")
public class AndroidGetRecipeDishesDetailVO implements Serializable {
   @ApiModelProperty("菜品id")
   private Long dishesId;
   @ApiModelProperty("菜品名称")
   private String dishesName;
   @ApiModelProperty("菜品图片")
   private String dishesImgUrl;
   @ApiModelProperty("菜谱详情id")
   private Long detailId;
   @ApiModelProperty("库存数量")
   private Integer surplusNum;
   @ApiModelProperty("限购数量")
   private Integer restrictNum;
   @ApiModelProperty("菜品价格")
   private Integer dishesPrice;
   @ApiModelProperty("优惠价")
   private Integer prefPrice;
   @ApiModelProperty("食堂id")
   private Long canteenId;
   @ApiModelProperty("食堂名称")
   private String canteenName;
   @ApiModelProperty("档口id")
   private Long shopstallId;
   @ApiModelProperty("档口名称")
   private String shopstallName;
   @ApiModelProperty("商品规格(g)")
   private BigDecimal weight;
   @ApiModelProperty("热量(千卡/100g)")
   private BigDecimal calories;
   @ApiModelProperty("蛋白质(g/100g)")
   private BigDecimal protein;
   @ApiModelProperty("脂肪(g/100g)")
   private BigDecimal fat;
   @ApiModelProperty("碳水化合物(g/100g)")
   private BigDecimal carbohydrate;
   @ApiModelProperty("膳食纤维(g/100g)")
   private BigDecimal dietaryFiber;
   @ApiModelProperty("胆固醇(mg/100g)")
   private BigDecimal cholesterol;
   @ApiModelProperty("钙(mg/100g)")
   private BigDecimal calcium;
   @ApiModelProperty("钠(mg/100g)")
   private BigDecimal sodium;
   @ApiModelProperty("热量NRV(千卡/100g)")
   private BigDecimal caloriesNrv;
   @ApiModelProperty("蛋白质NRV(g/100g)")
   private BigDecimal proteinNrv;
   @ApiModelProperty("脂肪NRV(g/100g)")
   private BigDecimal fatNrv;
   @ApiModelProperty("碳水化合物NRV(g/100g)")
   private BigDecimal carbohydrateNrv;
   @ApiModelProperty("膳食纤维NRV(g/100g)")
   private BigDecimal dietaryFiberNrv;
   @ApiModelProperty("胆固醇NRV(mg/100g)")
   private BigDecimal cholesterolNrv;
   @ApiModelProperty("钙NRV(mg/100g)")
   private BigDecimal calciumNrv;
   @ApiModelProperty("钠NRV(mg/100g)")
   private BigDecimal sodiumNrv;

   public String getDishesImgUrl() {
      return SysUtil.getCutFileUrl(this.dishesImgUrl);
   }

   public BigDecimal getCaloriesNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.calories).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).multiply(new BigDecimal("4.185")).divide(new BigDecimal("8400"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getProteinNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.protein).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("60"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getFatNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.fat).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("60"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getCarbohydrateNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.carbohydrate).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("300"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getDietaryFiberNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.dietaryFiber).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("25"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getCholesterolNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.cholesterol).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("300"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getCalciumNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.calcium).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("800"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public BigDecimal getSodiumNrv() {
      return !ObjectUtil.isNull(this.weight) && !NumberUtil.equals(this.weight, BigDecimal.ZERO) ? ((BigDecimal)Optional.ofNullable(this.sodium).orElse(BigDecimal.ZERO)).divide(this.weight, 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP).divide(new BigDecimal("2000"), 4, RoundingMode.HALF_UP).multiply(new BigDecimal("100")).setScale(2, RoundingMode.HALF_UP) : BigDecimal.ZERO;
   }

   public Long getDishesId() {
      return this.dishesId;
   }

   public String getDishesName() {
      return this.dishesName;
   }

   public Long getDetailId() {
      return this.detailId;
   }

   public Integer getSurplusNum() {
      return this.surplusNum;
   }

   public Integer getRestrictNum() {
      return this.restrictNum;
   }

   public Integer getDishesPrice() {
      return this.dishesPrice;
   }

   public Integer getPrefPrice() {
      return this.prefPrice;
   }

   public Long getCanteenId() {
      return this.canteenId;
   }

   public String getCanteenName() {
      return this.canteenName;
   }

   public Long getShopstallId() {
      return this.shopstallId;
   }

   public String getShopstallName() {
      return this.shopstallName;
   }

   public BigDecimal getWeight() {
      return this.weight;
   }

   public BigDecimal getCalories() {
      return this.calories;
   }

   public BigDecimal getProtein() {
      return this.protein;
   }

   public BigDecimal getFat() {
      return this.fat;
   }

   public BigDecimal getCarbohydrate() {
      return this.carbohydrate;
   }

   public BigDecimal getDietaryFiber() {
      return this.dietaryFiber;
   }

   public BigDecimal getCholesterol() {
      return this.cholesterol;
   }

   public BigDecimal getCalcium() {
      return this.calcium;
   }

   public BigDecimal getSodium() {
      return this.sodium;
   }

   public void setDishesId(final Long dishesId) {
      this.dishesId = dishesId;
   }

   public void setDishesName(final String dishesName) {
      this.dishesName = dishesName;
   }

   public void setDishesImgUrl(final String dishesImgUrl) {
      this.dishesImgUrl = dishesImgUrl;
   }

   public void setDetailId(final Long detailId) {
      this.detailId = detailId;
   }

   public void setSurplusNum(final Integer surplusNum) {
      this.surplusNum = surplusNum;
   }

   public void setRestrictNum(final Integer restrictNum) {
      this.restrictNum = restrictNum;
   }

   public void setDishesPrice(final Integer dishesPrice) {
      this.dishesPrice = dishesPrice;
   }

   public void setPrefPrice(final Integer prefPrice) {
      this.prefPrice = prefPrice;
   }

   public void setCanteenId(final Long canteenId) {
      this.canteenId = canteenId;
   }

   public void setCanteenName(final String canteenName) {
      this.canteenName = canteenName;
   }

   public void setShopstallId(final Long shopstallId) {
      this.shopstallId = shopstallId;
   }

   public void setShopstallName(final String shopstallName) {
      this.shopstallName = shopstallName;
   }

   public void setWeight(final BigDecimal weight) {
      this.weight = weight;
   }

   public void setCalories(final BigDecimal calories) {
      this.calories = calories;
   }

   public void setProtein(final BigDecimal protein) {
      this.protein = protein;
   }

   public void setFat(final BigDecimal fat) {
      this.fat = fat;
   }

   public void setCarbohydrate(final BigDecimal carbohydrate) {
      this.carbohydrate = carbohydrate;
   }

   public void setDietaryFiber(final BigDecimal dietaryFiber) {
      this.dietaryFiber = dietaryFiber;
   }

   public void setCholesterol(final BigDecimal cholesterol) {
      this.cholesterol = cholesterol;
   }

   public void setCalcium(final BigDecimal calcium) {
      this.calcium = calcium;
   }

   public void setSodium(final BigDecimal sodium) {
      this.sodium = sodium;
   }

   public void setCaloriesNrv(final BigDecimal caloriesNrv) {
      this.caloriesNrv = caloriesNrv;
   }

   public void setProteinNrv(final BigDecimal proteinNrv) {
      this.proteinNrv = proteinNrv;
   }

   public void setFatNrv(final BigDecimal fatNrv) {
      this.fatNrv = fatNrv;
   }

   public void setCarbohydrateNrv(final BigDecimal carbohydrateNrv) {
      this.carbohydrateNrv = carbohydrateNrv;
   }

   public void setDietaryFiberNrv(final BigDecimal dietaryFiberNrv) {
      this.dietaryFiberNrv = dietaryFiberNrv;
   }

   public void setCholesterolNrv(final BigDecimal cholesterolNrv) {
      this.cholesterolNrv = cholesterolNrv;
   }

   public void setCalciumNrv(final BigDecimal calciumNrv) {
      this.calciumNrv = calciumNrv;
   }

   public void setSodiumNrv(final BigDecimal sodiumNrv) {
      this.sodiumNrv = sodiumNrv;
   }

}
